<?php

/*
	Copyright (C) 2003-2007 UseBB Team
	http://www.usebb.net
	
	$Header: /cvsroot/usebb/UseBB/sources/edit_topic.php,v 1.34 2007/01/01 11:58:47 pc_freak Exp $
	
	This file is part of UseBB.
	
	UseBB is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	UseBB is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with UseBB; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
 * Edit topic interface
 *
 * Interface to editing topics.
 *
 * @author	UseBB Team
 * @link	http://www.usebb.net
 * @license	GPL-2
 * @version	$Revision: 1.34 $
 * @copyright	Copyright (C) 2003-2007 UseBB Team
 * @package	UseBB
 */

//
// Die when called directly in browser
//
if ( !defined('INCLUDED') )
	exit();

//
// Delete topics
//
if ( $_GET['act'] == 'delete' ) {
	
	$session->update('deletetopic:'.$_GET['topic']);
	
	//
	// Include the page header
	//
	require(ROOT_PATH.'sources/page_head.php');
	
	//
	// Get info about the topic
	//
	$result = $db->query("SELECT t.id, t.forum_id, t.topic_title, t.count_replies, f.name AS forum_name, f.auth, f.last_topic_id, f.increase_post_count FROM ".TABLE_PREFIX."topics t, ".TABLE_PREFIX."forums f WHERE t.forum_id = f.id AND t.id = ".$_GET['topic']);
	$topicdata = $db->fetch_result($result);
	
	if ( !$topicdata['id'] ) {
		
		//
		// This topic does not exist
		//
		header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');
		$template->set_page_title($lang['Error']);
		$template->parse('msgbox', 'global', array(
			'box_title' => $lang['Error'],
			'content' => sprintf($lang['NoSuchTopic'], 'ID '.$_GET['topic'])
		));
		
	} else {
		
		//
		// Only if the user can delete topics
		//
		if ( $functions->auth($topicdata['auth'], 'delete', $topicdata['forum_id']) ) {
			
			if ( $_SERVER['REQUEST_METHOD'] == 'POST' ) {
				
				if ( !empty($_POST['delete']) ) {
					
					$forum_counts_updated = false;
					
					//
					// 1. Delete the topic entry
					//
					$result = $db->query("DELETE FROM ".TABLE_PREFIX."topics WHERE id = ".$_GET['topic']);
					
					//
					// 2. Adjust latest updated topic of forum if needed
					//
					if ( $topicdata['last_topic_id'] == $_GET['topic'] ) {
						
						$result = $db->query("SELECT p.topic_id FROM ".TABLE_PREFIX."posts p, ".TABLE_PREFIX."topics t WHERE p.topic_id = t.id AND t.forum_id = ".$topicdata['forum_id']." ORDER BY p.post_time DESC LIMIT 1");
						$lasttopicdata = $db->fetch_result($result);
						
						if ( !$lasttopicdata['topic_id'] ) {
							
							$result = $db->query("UPDATE ".TABLE_PREFIX."forums SET topics = 0, posts = 0, last_topic_id = 0 WHERE id = ".$topicdata['forum_id']);
							
							$forum_counts_updated = true;
							
						} else {
							
							$update_last_topic_id = ', last_topic_id = '.$lasttopicdata['topic_id'];
							
						}
						
					} else {
						
						$update_last_topic_id = '';
						
					}
					
					//
					// 3. Update the forum's counters
					//
					if ( !$forum_counts_updated ) {
						
						$result = $db->query("UPDATE ".TABLE_PREFIX."forums SET topics = topics-1, posts = posts-". ( $topicdata['count_replies']+1 ) .$update_last_topic_id." WHERE id = ".$topicdata['forum_id']);
						
					}
					
					//
					// 4. Adjust users' posts levels by defining which users posted and how many posts made
					//
					if ( $topicdata['increase_post_count'] ) {
						
						$result = $db->query("SELECT poster_id FROM ".TABLE_PREFIX."posts WHERE topic_id = ".$_GET['topic']);
						
						$users_posted = array();
						while ( $postsdata = $db->fetch_result($result) ) {
							
							if ( !array_key_exists($postsdata['poster_id'], $users_posted) )
								$users_posted[$postsdata['poster_id']] = 1;
							else
								$users_posted[$postsdata['poster_id']]++;
							
						}
						
						//
						// Adjust the count for every user that posted
						//
						foreach ( $users_posted as $userid => $postcount )
							$result = $db->query("UPDATE ".TABLE_PREFIX."members SET posts = posts-".$postcount." WHERE id = ".$userid);
						
					}
					
					//
					// 5. Delete posts within the deleted topic
					//
					$result = $db->query("DELETE FROM ".TABLE_PREFIX."posts WHERE topic_id = ".$_GET['topic']);
					
					//
					// 6. Adjust stats
					//
					$result = $db->query("UPDATE ".TABLE_PREFIX."stats SET content = content-1 WHERE name = 'topics'");
					
					$result = $db->query("UPDATE ".TABLE_PREFIX."stats SET content = content-". ( $topicdata['count_replies']+1 ) ." WHERE name = 'posts'");
					
					$functions->redirect('forum.php', array('id' => $topicdata['forum_id']));
					
				} else {
					
					$functions->redirect('topic.php', array('id' => $_GET['topic']));
					
				}
				
			} else {
				
				$template->set_page_title($lang['DeleteTopic']);
				
				$template->parse('confirm_form', 'global', array(
					'form_begin' => '<form action="'.$functions->make_url('edit.php', array('topic' => $_GET['topic'], 'act' => 'delete')).'" method="post">',
					'title' => $lang['DeleteTopic'],
					'content' => sprintf($lang['ConfirmDeleteTopic'], '<em>'.unhtml(stripslashes($topicdata['topic_title'])).'</em>', '<em>'.unhtml(stripslashes($topicdata['forum_name'])).'</em>'),
					'submit_button' => '<input type="submit" name="delete" value="'.$lang['Yes'].'" />',
					'cancel_button' => '<input type="submit" value="'.$lang['Cancel'].'" />',
					'form_end' => '</form>'
				));
				
			}
			
		} else {
			
			$functions->redir_to_login();
			
		}
		
	}
	
	//
	// Include the page footer
	//
	require(ROOT_PATH.'sources/page_foot.php');
	
} elseif ( $_GET['act'] == 'posts' ) {

	//
	// Move posts
	//
	$session->update($_GET['act'].'topic:'.$_GET['topic']);
		
	//
	// Include the page header
	//
	require(ROOT_PATH.'sources/page_head.php');
	
	//
	// Get topic information
	//
	$result = $db->query("SELECT t.id, t.topic_title, t.forum_id, t.count_replies, p.post_time, f.name AS forum_name, f.auth, f.last_topic_id FROM ".TABLE_PREFIX."topics t, ".TABLE_PREFIX."posts p, ".TABLE_PREFIX."forums f WHERE t.forum_id = f.id AND p.id = t.last_post_id AND t.id = ".$_GET['topic']);
	$topicdata = $db->fetch_result($result);
	
	if ( !$topicdata['id'] ) {
		
		//
		// I didn't see that topic!?
		//
		header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');
		$template->set_page_title($lang['Error']);
		$template->parse('msgbox', 'global', array(
			'box_title' => $lang['Error'],
			'content' => sprintf($lang['NoSuchTopic'], 'ID '.$_GET['topic'])
		));
		
	} else {
		
		//
		// If the user is granted to move topics, they can move posts too
		//
		if ( $functions->auth($topicdata['auth'], 'move', $topicdata['forum_id']) ) {
					
			if ( isset($_POST['postid']) || !empty($_POST['postid']) ) {
				$total_posts = count($_POST['postid']);
				$posts = implode(",",$_POST['postid']);
			} else {
				$total_posts = 0;
				$posts = '';
			}
			
			//
			// Start some main form error catching.  Before anything is submitted.
			//
			
			$merge_all_info = '';
			$merge_all_disabled = '';
			$new_topic_info = '';
			$new_topic_disabled = '';
			$existing_topic_disabled = '';
			$no_posts_info = '';
			
			if ( $total_posts <= 1 ) {
				$merge_all_info = $lang['MergeAllInfo'];
				$merge_all_disabled = 'disabled="disabled"';
			} else {
				$merge_all_info = $lang['MergeAllInfo2'].$total_posts.$lang['MergeAllInfo3'];
			}
			
			if ( $total_posts-1 == $topicdata['count_replies'] ) {
				$new_topic_info = '<tr><td colspan="2" class="count">'.$lang['NewTopicInfo'].'</td></tr>';
				$new_topic_disabled = 'disabled="disabled"';
			}
			
			if ( $total_posts == 0 ) {
				$no_posts_info = '<tr><td colspan="2" class="count">'.$lang['NoPostInfo'].'</td></tr>';
				$merge_all_disabled = 'disabled="disabled"';
				$new_topic_disabled = 'disabled="disabled"';
				$existing_topic_disabled = 'disabled="disabled"';
			}
			
			
			//
			// Create a new topic from selected posts
			//
			if ( isset($_POST['new']) ) {
			
				$tmp = $_POST['total_posts'];
				//
				// Get new information
				//
				if ( !empty($_POST['new_forum_id']) && valid_int($_POST['new_forum_id']) && !empty($_POST['new_topic_name']) ) {
				
					if ( $topicdata['count_replies'] == $tmp-1 ) {
					
						//
						// dont allow any further, waste of resources, just move the whole topic
						//
						$template->set_page_title($lang['Error']);
						$template->parse('msgbox', 'global', array(
							'box_title' => $lang['Error'],
							'content' => $lang['NewTopicInfo']
						));
						
					} else {
						

						//
						// Update the old thread with the new post count & latest post id
						//
						$new_reply_count = ($topicdata['count_replies'] - $_POST['total_posts']);
					
						$result = $db->query("SELECT p.topic_id,p.id FROM ".TABLE_PREFIX."posts p, ".TABLE_PREFIX."topics t WHERE p.topic_id = t.id AND t.forum_id = ".$topicdata['forum_id']." ORDER BY p.post_time ASC LIMIT 1");
						$lasttopicdata = $db->fetch_result($result);
						
						$db->query("UPDATE ".TABLE_PREFIX."topics SET count_replies = $new_reply_count, last_post_id = ".$lasttopicdata['id']." WHERE id = ".$lasttopicdata['topic_id']."");
						
						//
						// Create the new topic
						//
						$postid = explode(",",$_POST['new_posts']);
						$topic_first_post = $postid[0];
						$topic_last_post = $postid[$_POST['total_posts']-1];
						$new_forum_id = $_POST['new_forum_id'];
						$new_topic_title = $_POST['new_topic_name'];
						$new_replies = $_POST['total_posts']-1;
						$db->query("INSERT INTO ".TABLE_PREFIX."topics VALUES(NULL, ".$new_forum_id.", '".$new_topic_title."', $topic_first_post, $topic_last_post, $new_replies, 0, 0, 0)");
						
						$inserted_topic_id = $db->last_id();
						
						//
						// Update each of the posts to reflect the new topic id
						//
					  	$nposts = $_POST['new_posts'];
					  	$db->query("UPDATE ".TABLE_PREFIX."posts SET topic_id = $inserted_topic_id WHERE id IN ($nposts)");
						
						//
						// Update old forum to put the posts down. Only if it's a different forum.
						//
						if ( $topicdata['forum_id'] != $new_forum_id ) {
							$addon = $_POST['total_posts'];
							$addonq = 'posts = posts+'.$addon.',';
							$db->query("UPDATE ".TABLE_PREFIX."forums SET posts = posts-$addon WHERE id = ".$topicdata['forum_id']."");
						} else {
							$addon = '';
							$addonq = '';
						}
				
						$result = $db->query("UPDATE ".TABLE_PREFIX."forums SET topics = topics+1,$addonq last_topic_id = $inserted_topic_id WHERE id = $new_forum_id");
						
						//
						// Update the global stats
						//
						$result = $db->query("UPDATE ".TABLE_PREFIX."stats SET content = content+1 WHERE name = 'topics'");
					
						$template->set_page_title($lang['Note']);
						$template->parse('msgbox', 'global', array(
							'box_title' => $lang['Note'],
							'content' => $lang['SucessMsg1'].' <a href="'.$functions->make_url('topic.php', array('id' => $inserted_topic_id)).'">'.unhtml(stripslashes($new_topic_title)).'</a>'
						));

					}
				}
			
			//
			// Merge selected posts into an existing topic
			//
			} elseif ( isset($_POST['merge']) ) {
			
				if ( !empty($_POST['existing_topic_id']) && valid_int($_POST['existing_topic_id']) && $topicdata['id'] != $_POST['existing_topic_id'] ) {
						$nposts = $_POST['new_posts'];
						$new_topic_id = $_POST['existing_topic_id'];
						
						//
						// Get info from the new topic ID
						//
						$result = $db->query("SELECT id,topic_title,forum_id,count_replies FROM ".TABLE_PREFIX."topics WHERE id = $new_topic_id");
						$new_topicdata = $db->fetch_result($result);
						
						$new_forum_id = $new_topicdata['forum_id'];
						
						if ( !$new_topicdata['id'] ) {
							
							header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');
							$template->set_page_title($lang['Error']);
							$template->parse('msgbox', 'global', array(
								'box_title' => $lang['Error'],
								'content' => sprintf($lang['NoSuchTopic'], 'ID '.$new_topic_id)
							));
						
						} else {
										
							//
							// Update each of the posts to reflect the new topic id
							//
						  	$db->query("UPDATE ".TABLE_PREFIX."posts SET topic_id = $new_topic_id WHERE id IN ($nposts)");
														
							//
							// Update the forum replies in both old and new forums. Only if it's a different forum.
							//
							if ( $topicdata['forum_id'] != $new_topicdata['forum_id'] ) {
								$addon = $_POST['total_posts'];
								$db->query("UPDATE ".TABLE_PREFIX."forums SET posts = posts-$addon WHERE id = ".$topicdata['forum_id']."");
								$db->query("UPDATE ".TABLE_PREFIX."forums SET posts = posts+$addon WHERE id = ".$new_topicdata['forum_id']."");
							}
						
							//
							// Only update the old topic if all posts weren't selected.  Also update topic count correctly
							//
							if ( $topicdata['count_replies'] != $_POST['total_posts']-1 ) {
							
								$new_reply_count = $_POST['total_posts'];
								$forum = $topicdata['forum_id'];
								$db->query("UPDATE ".TABLE_PREFIX."topics SET count_replies = count_replies-$new_reply_count WHERE id = ".$topicdata['id']."");
							
							} else {
								
								$forum = $new_topicdata['forum_id'];
								$db->query("UPDATE ".TABLE_PREFIX."forums SET topics = topics-1 WHERE id = ".$topicdata['forum_id']."");
								$db->query("UPDATE ".TABLE_PREFIX."stats SET content = content-1 WHERE name = 'topics'");
								$db->query("DELETE FROM ".TABLE_PREFIX."topics WHERE id = ".$topicdata['id']."");
								
								//
								// Get the new last topic id if the topic was deleted
								//
								$result = $db->query("SELECT id FROM ".TABLE_PREFIX."topics WHERE forum_id = ".$topicdata['forum_id']." ORDER BY id DESC LIMIT 1");
								$lasttopicdata = $db->fetch_result($result);
								
								if ( $lasttopicdata['id'] != null ) {
								
								$db->query("UPDATE ".TABLE_PREFIX."forums SET last_topic_id = ".$lasttopicdata['id']." WHERE id = ".$topicdata['forum_id']."");
								}
								
							}
							
							//
							// Update old/new topic id with new last post info
							//
							$result = $db->query("SELECT p.topic_id,p.id FROM ".TABLE_PREFIX."posts p, ".TABLE_PREFIX."topics t WHERE p.topic_id = t.id AND t.forum_id = $forum ORDER BY p.post_time DESC LIMIT 1");
							$lasttopicdata = $db->fetch_result($result);
						
						$db->query("UPDATE ".TABLE_PREFIX."topics SET count_replies = count_replies+".$_POST['total_posts'].", last_post_id = ".$lasttopicdata['id']." WHERE id = ".$new_topicdata['id']."");
							
							$template->set_page_title($lang['Note']);
							$template->parse('msgbox', 'global', array(
								'box_title' => $lang['Note'],
								'content' => $lang['SuccessMsg2'].' <a href="'.$functions->make_url('topic.php', array('id' => $new_topicdata['id'])).'">'.unhtml(stripslashes($new_topicdata['topic_title'])).'</a><br />'.$lang['SuccessMsgInfo']
								
							));
							
						}
						
				} else {
				
						$template->set_page_title($lang['Error']);
						$template->parse('msgbox', 'global', array(
							'box_title' => $lang['Error'],
							'content' => $lang['ErrorMsg1']
						));
						
				}
			
			//
			// Merge seletected posts into a single post
			//
			} elseif ( isset($_POST['merge_all']) ) {
			
				$nposts = $_POST['new_posts'];
				$total_posts = $_POST['total_posts'];
				$tmp = 1;
				$postsa = explode(",",$_POST['new_posts']);
				$destination_post = $postsa[0];
				$new_content = '';
				
				//
				// Get all the selected posts and save the post content
				//
				$result = $db->query("SELECT content FROM ".TABLE_PREFIX."posts WHERE id IN ($nposts) ORDER BY id ASC");
				
				while ( $post_content = $db->fetch_result($result) ) {
				
					$new_content .= $post_content['content'].'\n\n';
				}
				
				$db->query("UPDATE ".TABLE_PREFIX."posts SET content = '$new_content' WHERE id = $destination_post");

				//
				// Remove each of the posts that were merged
				//
				$remove_posts = array();
				array_shift($postsa);
				$remove_posts = implode(",", $postsa);
				
				$db->query("DELETE FROM ".TABLE_PREFIX."posts WHERE id IN ($remove_posts)");
				
				//
				// Update the last post ID and new reply count
				//
				$drop_count = $total_posts-1;
				$db->query("UPDATE ".TABLE_PREFIX."topics SET count_replies = count_replies-$drop_count, last_post_id = $destination_post WHERE id = ".$topicdata['id']."");	

				//
				// Update the forum count
				//
				$db->query("UPDATE ".TABLE_PREFIX."forums SET posts = posts-$drop_count WHERE id = ".$topicdata['forum_id']."");				
				
				//
				// Update global stats
				//
				$new_count = $total_posts-1;
				$db->query("UPDATE ".TABLE_PREFIX."stats SET content = content-$new_count WHERE name = 'posts'");
				
				$template->set_page_title($lang['Note']);
				$template->parse('msgbox', 'global', array(
					'box_title' => $lang['Note'],
					'content' => $lang['SuccessMsg3'].' <a href="'.$functions->make_url('topic.php', array('id' => $topicdata['id'])).'">'.unhtml(stripslashes($topicdata['topic_title'])).'</a>'
				));
					
			} else {
		
				$template->set_page_title($lang['MovePosts']);
				
				$result = $db->query("SELECT c.id AS cat_id, c.name AS cat_name, f.id, f.name, f.auth FROM ".TABLE_PREFIX."cats c, ".TABLE_PREFIX."forums f WHERE c.id = f.cat_id ORDER BY c.sort_id ASC, c.name ASC, f.sort_id ASC, f.name ASC");
				$forums = array();
				while ( $forumdata = $db->fetch_result($result) ) {
					
					if ( $functions->auth($forumdata['auth'], 'view', $forumdata['id']) )
						$forums[] = $forumdata;
					
				}
				if ( !count($forums) ) {
					
					$functions->redirect('topic.php', array('id' => $_GET['topic']));
					
				} elseif ( count($forums) === 1 ) {
					
					$forumdata = $forums[0];
					$new_forum_input = '<a href="'.$functions->make_url('forum.php', array('id' => $forumdata['id'])).'">'.unhtml(stripslashes($forumdata['name'])).'</a><input type="hidden" name="new_forum_id" value="'.$forumdata['id'].'" />';
					
				} else {
					
					//
					// Get a list of available forums to move to
					//
					$new_forum_input = '<select name="new_forum_id" '.$new_topic_disabled.'>';
					$seen_cats = array();
					foreach ( $forums as $forumdata ) {
						
						if ( !in_array($forumdata['cat_id'], $seen_cats) ) {
							
							$new_forum_input .= ( !count($seen_cats) ) ? '' : '</optgroup>';
							$new_forum_input .= '<optgroup label="'.unhtml(stripslashes($forumdata['cat_name'])).'">';
							$seen_cats[] = $forumdata['cat_id'];
							
						}
						
						$new_forum_input .= '<option value="'.$forumdata['id'].'">'.unhtml(stripslashes($forumdata['name'])).'</option>';
						
					}
					$new_forum_input .= '</optgroup></select>';
					
				}
				
				$template->parse('move_selected_posts_main', 'various', array(
					'form_begin' => '<form action="'.$functions->make_url('edit.php', array('topic' => $_GET['topic'], 'act' => 'posts')).'" method="post">',
					'topic_v' => '<a href="'.$functions->make_url('topic.php', array('id' => $_GET['topic'])).'">'.unhtml(stripslashes($topicdata['topic_title'])).'</a>',
					'old_forum_v' => '<a href="'.$functions->make_url('forum.php', array('id' => $topicdata['forum_id'])).'">'.unhtml(stripslashes($topicdata['forum_name'])).'</a>',
					'new_forum_input' => $new_forum_input,
					'total_posts' => $total_posts,
					'hidden_inputs' => '<input type="hidden" value="'.$total_posts.'" name="total_posts" /><input type="hidden" value="'.$posts.'" name="new_posts" />',
					'existing_topic_id' => '<input type="text" name="existing_topic_id" value="" size="5" '.$existing_topic_disabled.' />',
					'board_url' => $functions->get_config('board_url'),
					'new_topic_input' => '<input type="text" name="new_topic_name" '.$new_topic_disabled.' value="RE: '.unhtml(stripslashes($topicdata['topic_title'])).'" />',
					'merge_all_info' => $merge_all_info,
					'new_topic_info' => $new_topic_info,
					'no_posts_info' => $no_posts_info,
					'submit_button_new' => '<input type="submit" name="new" value="'.$lang['NewTopicButton'].'" '.$new_topic_disabled.' />',
					'submit_button_merge' => '<input type="submit" name="merge" value="'.$lang['MergeExistingButton'].'" '.$existing_topic_disabled.' />',
					'submit_button_merge_all' => '<input type="submit" name="merge_all" value="'.$lang['MergeAllButton'].'" '.$merge_all_disabled.' />',
					'cancel_button' => '<input type="submit" value="'.$lang['Cancel'].'" />',
					'form_end' => '</form>'
				));
				
			}
			
		}					
	}
	
	//
	// Include the page footer
	//
	require(ROOT_PATH.'sources/page_foot.php');
	
} elseif ( $_GET['act'] == 'move' ) {
	
	//
	// Move topics
	//
	$session->update($_GET['act'].'topic:'.$_GET['topic']);
		
	//
	// Include the page header
	//
	require(ROOT_PATH.'sources/page_head.php');
	
	//
	// Get topic information
	//
	$result = $db->query("SELECT t.id, t.topic_title, t.forum_id, t.count_replies, p.post_time, f.name AS forum_name, f.auth, f.last_topic_id FROM ".TABLE_PREFIX."topics t, ".TABLE_PREFIX."posts p, ".TABLE_PREFIX."forums f WHERE t.forum_id = f.id AND p.id = t.last_post_id AND t.id = ".$_GET['topic']);
	$topicdata = $db->fetch_result($result);
	
	if ( !$topicdata['id'] ) {
		
		//
		// I didn't see that topic!?
		//
		header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');
		$template->set_page_title($lang['Error']);
		$template->parse('msgbox', 'global', array(
			'box_title' => $lang['Error'],
			'content' => sprintf($lang['NoSuchTopic'], 'ID '.$_GET['topic'])
		));
		
	} else {
		
		//
		// If the user is granted to move topics
		//
		if ( $functions->auth($topicdata['auth'], 'move', $topicdata['forum_id']) ) {
			
			if ( !empty($_POST['new_forum_id']) && valid_int($_POST['new_forum_id']) ) {
					
				if ( !empty($_POST['move']) ) {
					
					//
					// Get information about the new forum
					//
					$result = $db->query("SELECT f.id, f.last_topic_id, f.auth, p.post_time FROM ( ( ".TABLE_PREFIX."forums f LEFT JOIN ".TABLE_PREFIX."topics t ON t.id = f.last_topic_id ) LEFT JOIN ".TABLE_PREFIX."posts p ON p.id = t.last_post_id ) WHERE f.id = ".$_POST['new_forum_id']);
					$forumdata = $db->fetch_result($result);
					
					if ( !$forumdata['id'] ) {
						
						$functions->redirect('topic.php', array('id' => $_GET['topic']));
						
					} else {
						
						if ( !$functions->auth($forumdata['auth'], 'view', $_POST['new_forum_id']) ) {
							
							$functions->redirect('topic.php', array('id' => $_GET['topic']));
							
						} else {
							
							//
							// Move the topic
							//
							$result = $db->query("UPDATE ".TABLE_PREFIX."topics SET forum_id = ".$_POST['new_forum_id']." WHERE id = ".$_GET['topic']);
							$old_forum_counts_updated = false;
							
							if ( $topicdata['last_topic_id'] == $_GET['topic'] ) {
								
								//
								// Adjust the last updated topic
								//
								$result = $db->query("SELECT p.topic_id FROM ".TABLE_PREFIX."posts p, ".TABLE_PREFIX."topics t WHERE p.topic_id = t.id AND t.forum_id = ".$topicdata['forum_id']." ORDER BY p.post_time DESC LIMIT 1");
								$lasttopicdata = $db->fetch_result($result);
								
								if ( !$lasttopicdata['topic_id'] ) {
									
									$result = $db->query("UPDATE ".TABLE_PREFIX."forums SET topics = 0, posts = 0, last_topic_id = 0 WHERE id = ".$topicdata['forum_id']);
									
									$old_forum_counts_updated = true;
									
								} else {
									
									$update_old_last_topic_id = ', last_topic_id = '.$lasttopicdata['topic_id'];
									
								}
								
							} else {
								
								$update_old_last_topic_id = '';
								
							}
							
							$update_new_last_topic_id = ( $topicdata['post_time'] > $forumdata['post_time'] ) ? ', last_topic_id = '.$_GET['topic'] : '';
							
							//
							// Adjust forum counts
							//
							if ( !$old_forum_counts_updated ) {
								
								$result = $db->query("UPDATE ".TABLE_PREFIX."forums SET topics = topics-1, posts = posts-". ( $topicdata['count_replies']+1 ) .$update_old_last_topic_id." WHERE id = ".$topicdata['forum_id']);
								
							}
							
							$result = $db->query("UPDATE ".TABLE_PREFIX."forums SET topics = topics+1, posts = posts+". ( $topicdata['count_replies']+1 ) .$update_new_last_topic_id." WHERE id = ".$_POST['new_forum_id']);
							
							$functions->redirect('topic.php', array('id' => $_GET['topic']));
							
						}
						
					}
				
				} else {
					
					$functions->redirect('topic.php', array('id' => $_GET['topic']));
					
				}
				
			} else {
				
				$template->set_page_title($lang['MoveTopic']);
				
				$result = $db->query("SELECT c.id AS cat_id, c.name AS cat_name, f.id, f.name, f.auth FROM ".TABLE_PREFIX."cats c, ".TABLE_PREFIX."forums f WHERE c.id = f.cat_id AND f.id <> ".$topicdata['forum_id']." ORDER BY c.sort_id ASC, c.name ASC, f.sort_id ASC, f.name ASC");
				$forums = array();
				while ( $forumdata = $db->fetch_result($result) ) {
					
					if ( $functions->auth($forumdata['auth'], 'view', $forumdata['id']) )
						$forums[] = $forumdata;
					
				}
				if ( !count($forums) ) {
					
					$functions->redirect('topic.php', array('id' => $_GET['topic']));
					
				} elseif ( count($forums) === 1 ) {
					
					$forumdata = $forums[0];
					$new_forum_input = '<a href="'.$functions->make_url('forum.php', array('id' => $forumdata['id'])).'">'.unhtml(stripslashes($forumdata['name'])).'</a><input type="hidden" name="new_forum_id" value="'.$forumdata['id'].'" />';
					
				} else {
					
					//
					// Get a list of available forums to move to
					//
					$new_forum_input = '<select name="new_forum_id">';
					$seen_cats = array();
					foreach ( $forums as $forumdata ) {
						
						if ( !in_array($forumdata['cat_id'], $seen_cats) ) {
							
							$new_forum_input .= ( !count($seen_cats) ) ? '' : '</optgroup>';
							$new_forum_input .= '<optgroup label="'.unhtml(stripslashes($forumdata['cat_name'])).'">';
							$seen_cats[] = $forumdata['cat_id'];
							
						}
						
						$new_forum_input .= '<option value="'.$forumdata['id'].'">'.unhtml(stripslashes($forumdata['name'])).'</option>';
						
					}
					$new_forum_input .= '</optgroup></select>';
					
				}
				
				$template->parse('move_topic_form', 'various', array(
					'form_begin' => '<form action="'.$functions->make_url('edit.php', array('topic' => $_GET['topic'], 'act' => 'move')).'" method="post">',
					'topic_v' => '<a href="'.$functions->make_url('topic.php', array('id' => $_GET['topic'])).'">'.unhtml(stripslashes($topicdata['topic_title'])).'</a>',
					'old_forum_v' => '<a href="'.$functions->make_url('forum.php', array('id' => $topicdata['forum_id'])).'">'.unhtml(stripslashes($topicdata['forum_name'])).'</a>',
					'new_forum_input' => $new_forum_input,
					'submit_button' => '<input type="submit" name="move" value="'.$lang['OK'].'" />',
					'cancel_button' => '<input type="submit" value="'.$lang['Cancel'].'" />',
					'form_end' => '</form>'
				));
				
			}
			
		} else {
			
			$functions->redir_to_login();
			
		}
		
	}
	
	//
	// Include the page footer
	//
	require(ROOT_PATH.'sources/page_foot.php');
	
} elseif ( $_GET['act'] == 'lock' ) {
	
	//
	// Lock topics
	//
	$session->update();
	
	$result = $db->query("SELECT t.id, t.status_locked, f.id, f.auth FROM ".TABLE_PREFIX."topics t, ".TABLE_PREFIX."forums f WHERE t.id = ".$_GET['topic']." AND f.id = t.forum_id");
	$topicdata = $db->fetch_result($result);
	
	if ( !$topicdata['id'] ) {
		
		$functions->redirect('topic.php', array('id' => $_GET['topic']));
		
	} else {
		
		if ( !$functions->auth($topicdata['auth'], 'lock', $topicdata['id']) ) {
			
			//
			// Include the page header
			//
			require(ROOT_PATH.'sources/page_head.php');
			
			$functions->redir_to_login();
			
			//
			// Include the page footer
			//
			require(ROOT_PATH.'sources/page_foot.php');
			
		} else {
			
			if ( $topicdata['status_locked'] ) {
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			} else {
				
				$result = $db->query("UPDATE ".TABLE_PREFIX."topics SET status_locked = 1 WHERE id = ".$_GET['topic']);
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			}
			
		}
		
	}
	
} elseif ( $_GET['act'] == 'unlock' ) {
	
	//
	// Unlock topics
	//
	$session->update();
	
	$result = $db->query("SELECT t.id, t.status_locked, f.id, f.auth FROM ".TABLE_PREFIX."topics t, ".TABLE_PREFIX."forums f WHERE t.id = ".$_GET['topic']." AND f.id = t.forum_id");
	$topicdata = $db->fetch_result($result);
	
	if ( !$topicdata['id'] ) {
		
		$functions->redirect('topic.php', array('id' => $_GET['topic']));
		
	} else {
		
		if ( !$functions->auth($topicdata['auth'], 'lock', $topicdata['id']) ) {
			
			//
			// Include the page header
			//
			require(ROOT_PATH.'sources/page_head.php');
			
			$functions->redir_to_login();
			
			//
			// Include the page footer
			//
			require(ROOT_PATH.'sources/page_foot.php');
			
		} else {
			
			if ( !$topicdata['status_locked'] ) {
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			} else {
				
				$result = $db->query("UPDATE ".TABLE_PREFIX."topics SET status_locked = 0 WHERE id = ".$_GET['topic']);
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			}
			
		}
		
	}
	
} elseif ( $_GET['act'] == 'sticky' ) {
	
	//
	// Sticky topics
	//
	$session->update();
	
	$result = $db->query("SELECT t.id, t.status_sticky, f.id, f.auth FROM ".TABLE_PREFIX."topics t, ".TABLE_PREFIX."forums f WHERE t.id = ".$_GET['topic']." AND f.id = t.forum_id");
	$topicdata = $db->fetch_result($result);
	
	if ( !$topicdata['id'] ) {
		
		$functions->redirect('topic.php', array('id' => $_GET['topic']));
		
	} else {
		
		if ( !$functions->auth($topicdata['auth'], 'sticky', $topicdata['id']) ) {
			
			//
			// Include the page header
			//
			require(ROOT_PATH.'sources/page_head.php');
			
			$functions->redir_to_login();
			
			//
			// Include the page footer
			//
			require(ROOT_PATH.'sources/page_foot.php');
			
		} else {
			
			if ( $topicdata['status_sticky'] ) {
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			} else {
				
				$result = $db->query("UPDATE ".TABLE_PREFIX."topics SET status_sticky = 1 WHERE id = ".$_GET['topic']);
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			}
			
		}
		
	}
	
} elseif ( $_GET['act'] == 'unsticky' ) {
	
	//
	// "Unsticky" topics
	// -does that word exist?-
	//
	$session->update();
	
	$result = $db->query("SELECT t.id, t.status_sticky, f.id, f.auth FROM ".TABLE_PREFIX."topics t, ".TABLE_PREFIX."forums f WHERE t.id = ".$_GET['topic']." AND f.id = t.forum_id");
	$topicdata = $db->fetch_result($result);
	
	if ( !$topicdata['id'] ) {
		
		$functions->redirect('topic.php', array('id' => $_GET['topic']));
		
	} else {
		
		if ( !$functions->auth($topicdata['auth'], 'sticky', $topicdata['id']) ) {
			
			//
			// Include the page header
			//
			require(ROOT_PATH.'sources/page_head.php');
			
			$functions->redir_to_login();
			
			//
			// Include the page footer
			//
			require(ROOT_PATH.'sources/page_foot.php');
			
		} else {
			
			if ( !$topicdata['status_sticky'] ) {
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			} else {
				
				$result = $db->query("UPDATE ".TABLE_PREFIX."topics SET status_sticky = 0 WHERE id = ".$_GET['topic']);
				
				$functions->redirect('topic.php', array('id' => $_GET['topic']));
				
			}
			
		}
		
	}
	
}

?>
